﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace TestXamDataChart {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        ObservableCollection<TonnageClassHolder> TonnageHolderCollection { get; set; } = new ObservableCollection<TonnageClassHolder>();
        public MainWindow() {
            InitializeComponent();
            DataContext = TonnageHolderCollection;
            Generate();
            }

        public void Generate() {

            System.Random randomEngine = new Random(DateTime.Now.Millisecond);
            TonnageHolderCollection.Clear();

            int numberSeries = Convert.ToInt32(tbNumberSeries.Text);

            for (int i = 0; i < 10; i++) {


                TonnageClassHolder tonnageHolder = new TonnageClassHolder() { PeriodID = i };

                tonnageHolder.TonnageCollection = new ObservableCollection<TonnageClass>();
                for (int j = 0; j < numberSeries; j++) {

                    tonnageHolder.TonnageCollection.Add(
                        new TonnageClass() { PeriodID = i, Tonnage = randomEngine.NextDouble() });
                    }
                TonnageHolderCollection.Add(tonnageHolder);
                }

            scChart.Series.Clear();

            int count = 0;
            for (int i = 0; i < numberSeries; i++) {
                var fragment = new Infragistics.Controls.Charts.StackedFragmentSeries();
                fragment.ValueMemberPath = String.Format("TonnageCollection[{0}].Tonnage", count--);
                scChart.Series.Add(fragment);
                count++;
            }

            }

        private void RegenCallback(object sender, RoutedEventArgs e) {
            Generate();
            TonnageHolderCollection[0].OnPropertyChanged("TonnageCollection");



            }
        }





    public class TonnageClassHolder : INotifyPropertyChanged {
        public int PeriodID { get; set; }
        public ObservableCollection<TonnageClass> TonnageCollection { get; set; } = new ObservableCollection<TonnageClass>();

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged([CallerMemberName] string propertyName = null) {
            //C# 6 null-safe operator. No need to check for event listeners
            //If there are no listeners, this will be a noop
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }
        }


    public class TonnageClass {
        public int PeriodID { get; set; }
        public double Tonnage { get; set; }

        }

    }
